/*
Copyright 2008  Nathan Bradshaw nathanlbradshaw@gmail.com

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public 
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "querymanager.h"
#include "querymanager_p.h"

using namespace ServiceModel;

QueryManager::QueryManager (QObject *parent) : QObject(parent), d_ptr(new QueryManagerPrivate())
{
   
}

QueryManager::QueryManager(QueryManagerPrivate &dd, QObject *parent) : QObject(parent), d_ptr(&dd)
{
   
}

QueryManager::~QueryManager ( )
{
   delete d_ptr;
}

int QueryManager::addQuery (Query *query, int serviceId)
{
   Q_D(QueryManager);
   d->addQuery(query, serviceId);
   
   return query->id();
}

int QueryManager::createServiceQueue (Service *service, int serviceId)
{
   Q_D(QueryManager);
   
   return d->addService(service, serviceId);
}

void QueryManager::startQueue (int serviceId)
{
   kDebug();
   Q_D(QueryManager);
   QueryManagerPrivate::QueryList* queryList = d->getServiceQueryList(serviceId);
   if (queryList) {
      QueryManagerPrivate::QueryList::ConstIterator i = queryList->constBegin();
      while (i != queryList->constEnd()) {
         kDebug() << "Executing " << i.key();
         i.value()->execute();
         ++i;
      }
   }
}

void QueryManager::pauseQueue (int serviceId)
{
   //\TODO implement me
   Q_UNUSED(serviceId);
}

int QueryManager::queueLenth (int serviceId) const
{
   //\TODO implement me
   Q_UNUSED(serviceId);
   return 0;
}

bool QueryManager::isProcessing (int serviceId) const
{
   //\TODO implement me
   Q_UNUSED(serviceId);
   return 0;
}

